#ifndef _H_PHYS_
#define _H_PHYS_

#include "draw.h"

typedef struct link link_t;
typedef struct convex convex_t;

enum {
	CONVEX_CONST		= 0x0010,
	CONVEX_SOFT		= 0x0020,
	CONVEX_BEND		= 0x0040
};

struct link {
	point_t		*beg;
	point_t		*end;
	float		dist;
};

struct convex {
	point_t		*last;
	point_t		*hold;
	point_t		*pts;
	int		pt;
	link_t		*lns;
	int		ln;
	int		flags;
	convex_t	*next;
	convex_t	*prev;
};

convex_t *phys_alloc(int len);
void phys_free(convex_t *cx);

void phys_insert(convex_t *cx);
void phys_remove(convex_t *cx);
void phys_remove_back();

void phys_open();
void phys_close();
void phys_update(float dt);
void phys_draw();

#endif /* _H_PHYS_ */

